//*****************************************************************************
//!
//! @file $Id: test_with_comparator.c 826 2008-02-28 14:23:24Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : PSC͂ƂĂ̔r0̎g
//!
//! @todo
//! @bug
//*****************************************************************************

//_____ ݸٰ _______________________________________________________________

#include "gcc_compiler.h"
#include <avr/io.h>

#include "pll_drv.h"

#include "psc_drv.h"

#include "comparator_drv.h"

/* PSC`Ԑݒ */
#define A_SA_VAL	100
#define A_RA_VAL	500
#define A_SB_VAL	600

#define B_SA_VAL	110
#define B_RA_VAL	80
#define B_SB_VAL	115

#define C_SA_VAL	60
#define C_RA_VAL	80
#define C_SB_VAL	90

#define RB_VAL		1250

#define PSC_PRESCALER			PSC_DIV_CLOCK_BY_256
#define PSC_CLOCK_SOURCE		PSC_CLOCK_SOURCE_EQ_PLL
#define PSC_MODE				PSC_MODE_ONE_RAMP

#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_HIGH
#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_HIGH

/* r0`Ԑݒ */
#define COMP0_ENABLE_BIT_VALUE	COMP_ENABLE
#define COMP0_INTERRUPT_ENABLE	COMP_DISABLE_INTERRUPT
#define COMP0_INTERRUPT_SELECT	COMP_INTERRUPT_ON_OUTPUT_TOGGLE
#define COMP_CLOCK_SOURCE		COMP_CLOCK_IO
#define COMP0_NEG_INPUT_SELECT	COMP_USE_NEGATIVE_PIN

/*F**************************************************************************
* NAME: PSC
*****************************************************************************/
void psc_init (void)
{
  Psc_enable_all_outputs();							// PSCSo͋

  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);		// PSC0rl
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);		// PSC1rl
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);		// PSC2rl
  Psc_set_register_RB(RB_VAL);						// ʔrl

  Psc_config();										// PSC`Ԑݒ
  Psc_config_input_0(PSC_OVERLAP_DISABLE,\
					 PSC_USE_COMPARATOR,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_DISACTIVATE_ALL_OUTPUTS);

  Psc_config_input_1(PSC_OVERLAP_DISABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_2(PSC_OVERLAP_DISABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

   Psc_run();										// PSCs
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/

int main (void){

  U16 temp;

  Start_pll_64_mega();								// PLL 64MHzn
  Wait_pll_ready();									// PLLҋ@
  DIDR0 = (1<<ADC5D);								/* ACMPN0D */
  DIDR1 = (1<<ACMP0D)|(1<<AMP0PD)|(1<<AMP0ND);
  Comp_0_config();									// r0`Ԑݒ
  psc_init();										// PSC
  while(1)
  {
	;
  }
} 
